from __future__ import print_function
import csv
import rx
from pprint import pprint
from rx import Observable
from pychart import *


def line_average(pair):
    lhs = pair[0]
    rhs = pair[1]
    result = [
        lhs[0],
        lhs[1],
        lhs[2],
        lhs[3],
        lhs[4]
    ]

    for i in xrange(5, len(lhs)):
        result.append((lhs[i] + rhs[i]) / 2)
    return result


def file_average_iterables(lhs, rhs):
    return map(line_average, zip(lhs, rhs))


def average(filenames):
    nombres_ficheros = Observable.from_iterable(filenames)
    contenido_ficheros = nombres_ficheros.map(lambda x: chart_data.read_csv(x)[1:])
    media_contenidos = contenido_ficheros.reduce(file_average_iterables)
    result = []
    media_contenidos.subscribe(lambda x: result.append(x))
    return result[0]


path = "../Benchmark_results/"
paths = [
    path+"result1.csv",
    path+"result2.csv",
    path+"result3.csv",
    path+"result4.csv",
    path+"result5.csv"
]

result = average(paths)
with open('computed-average.csv', 'wb') as myfile:
    wr = csv.writer(myfile)
    wr.writerows(result)
