# Conclusiones
La tecnología de memoria transaccional sobre hardware es una de las técnicas más recientes para el
tratamiento de acceso a recursos compartidos. Aunque la investigación académica sobre este tema no es
nada nuevo, sí lo es el cambio que produce el hecho de que Intel lo ponga a nuestra disposición en
sus procesadores dirigidos a consumidores a través de las instrucciones TSX.

La tecnología está en sus primeros momentos pero hemos podido comprobar que está lista para ser utilizada
y que proporciona un rendimiento comparable a un lock tradicional cuando no ofrece un rendimiento mejor.
En base a los datos proporcionados porla aplicación sintética realizada, vemos esta mejora del rendimiento en
ciertos casos como estructuras con muchas filas que eviten las colisiones de caché, o en el uso de un gran
número de hilos ya que con la memoria transaccional se evitan bloqueos que serializan la ejecución y por tanto
podemos aprovechar mejor el paralelismo de los actuales procesadores multinúcleo.

El análisis que hemos hecho en la introducción a esta tecnología se presenta de utilidad para seguir
utilizándola en aquellas aplicaciones en las que, a día de hoy, el uso de memoria transaccional no
solo facilita la programación sino que incluso mejora el rendimiento; pero también de cara al día de
mañana cuando nuevos procesadores de Intel sigan mejorando los límites técnicos de la memoria transaccional
(tamaño de líneas de caché, permitir más operaciones que no aborten la transacción, número de líneas de caché,
etc) y su uso comience a ser una opción válida, o incluso la mejor opción, para cada vez más aplicaciones.

Hemos podido comprobar de primera mano cómo la memoria transaccional demuestra su utilidad real, pero sobre
todo un gran potencial de cara al futuro, con una apuesta fuerte de una empresa del tamaño de Intel, decidida
a llevar esta tecnología a los ordenadores comunes y a añadir la memoria transaccional al cinturón de herramientas
de todo programador. Vemos esto como el inicio de una tendencia que, de consolidarse, podría contribuir a 
continuar el aumento de rendimiento del software a través del hardware, que parece que empieza a
ralentizarse en otras áreas; y podría animar a otras empresas que mostraron interés por la memoria transaccional
a decidirse a publicar un producto competidor.

## Trabajo futuro
En este trabajo nos hemos enfocado en realizar una prueba muy concreta sobre una tabla relativamente pequeña
y con un patrón de accesos aleatorio donde la mitad de ellos son de lectura y la otra mitad de escritura. Por
ello sería interesante de cara al futuro continuar con la experimentación y ver cómo se comporta la memoria
transaccional en otros tipos de aplicaciones, con otras estructuras compartidas, mayores tamaños, distintas
proporciones de tareas de lectura y escritura, etc.

Otra parte que también se presta a la futura investigación y que es dependiente del tipo de aplicación concreta
al que se quiera aplicar la memoria transaccional sería explorar posibles estrategias de recuperación cuando
usemos RTM, en lugar de caer directamente a un cerrojo global al primer fallo. Otras estrategias podrían ser
repetir la transacción esperando un tiempo antes o no antes de caer al cerrojo, o tomar esta decisión dinámicamente
teniendo la información sobre el estado y el funcionamiento de la aplicación-

No podemos olvidar tampoco seguir de cerca la evolución de la memoria transaccional hardware 
para repetir estos experimentos en futuro hardware que nos proporcione un número menor de fallos
y por tanto un mayor rendimiento.

Haciendo alusión al anterior capítulo de este trabajo, también es interesante continuar con la investigación
sobre Galois y comprobar hasta dónde puede llegar la idea de un framework que generalice el paralelismo, y sobre
todo ver si podemos mejorar esta aplicación introduciendo memoria transaccional y de qué forma, evitando
la implementación de una pseudo memoria transaccional en software.
