# Contenidos del CD-ROM
El CD incluye todos los ficheros generados durante la elaboración del trabajo.
Éste se divide en seis directorios que describiremos a continuación:

## Directorio _Benchmark_
Contiene el código del benchmark, compuesto por el fichero `TablaHash.c` y un 
fichero de encabezado asociado llamado `TablaHash.h`. El código está preparado
para ser compilado con el script `haz.sh`, para después ejecutarlo con el script
`lanza.sh`. Este último script tiene al inicio unas variables que permiten
configurar la forma de las ejecuciones sucesivas (número mínimo y máximo de
iteraciones, hilos, etc) y está configurado para que los resultados se vayan
añadiendo al fichero CSV que se le indique. Irá imprimiendo por pantalla el 
estado de la ejecución.

Este directorio contiene además el directorio `galoizedHashTable`, donde quedó
una prueba de portar el benchmark a C++ para integrarlo con Galois, que finalmente
no progresó.

## Directorio _Benchmark\_results_
Aquí se han almacenado todos los resultados en bruto de las distintas ejecuciones
del benchmark. En la carpeta `variable_workload_iter_x_thread` están los ficheros
CSV ejecutados con carga variable, es decir, con un número fijo de iteraciones por
hilo. Las demás carpetas se refieren a ejecuciones con carga constante, es decir,
con un número de iteraciones total independiente al número de hilos con que se ejecute.
Estas carpetas tienen un nombre que indica el número de iteraciones con las que se ha
ejecutado el benchmark, y en su interior almacenan ficheros de distintas ejecuciones
con ese parámetro.

## Directorio _Chart\_generation_
En este directorio encontramos las utilidades Python que nos sirven para hacer el 
preprocesamiento de los datos, la generación de las gráficas, etc. La ejecución se
realiza llamando al fichero `script.py`, donde se configura el proceso a seguir por
los datos. Este fichero llamará a `process.py`, donde se encuentran las rutinas para 
el preprocesamiento de los datos; y a `chart.py`, que es quien usa la biblioteca PyChart
para generar las gráficas.

También se encuentra en este directorio la utilidad `average.py`, que fue usada para hacer
una media aritmética de los datos de cinco ejecuciones con carga de trabajo variable. El
resultado de esta operación también se encuentra en `Benchmark_results`.

## Directorio _Documentation_
Este es el directorio que contiene los ficheros fuente de la elaboración de esta memoria.
El contenido se encuentra en formato markdown dividido en secciones en la carpeta `secciones`.
En la carpeta `latex` podemos ver algunos ficheros necesarios para la creación del documento
final. La carpeta `img` almacena categorizados en subcarpetas los gráficos generados a partir
de los datos, que después se referencian desde el documento. También están en esa carpeta
algunos diagramas creados.

En la raiz del directorio está el fichero `bibliografia.bib`, con la información bibliográfica
en formato _BibTeX_; y el fichero `main.mdpp` que define la estructura del documento y algunos
metadatos como el título, agradecimientos, autor, etc. 

## Directorio _Galois_
Ha sido usado para reunir información y notas sobre la investigación con Galois, información que
ha sido paulatinamente trasladada a la sección correspondiente de este trabajo.

## Directorio _Papers_
Aquí se reunieron publicaciones de interés para la elaboración del trabajo. Aunque están
referenciadas en la bibliografía, aquí se encuentran los documentos originales dispuestos
para la consulta cuando sea necesario.
